# $Header: /usr/custom/cvs/public/EasyPublisher/lib/python/Products/EasyEditor/Storage/Storage.py,v 1.1 2002/05/30 13:21:22 lennart Exp $
#
# (c) 2002, Torped Strategi och Kommunikation AB.
# See License.txt for License information.
#


__doc__="""Storage

$Torped: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Products.EasyEditor.EasyEditor import EasyStorage
from AccessControl import ClassSecurityInfo
#from Products.EasySecurity import EasyCorePermissions


class EasyStorageBase:

    def __init__(self,id):
        self.id = id

    def hasStorage(self,storageid):
        return EasyStorage.has_key(storageid)

    def getStorage(self,storageid,default=None):
        return EasyStorage.get(storageid, default)

    def storageIds(self,spec=None):
        return EasyStorage.keys()

    def storageValues(self,spec=None):
        return EasyStorage.values()

    def storageItems(self,spec=None):
        return  EasyStorage.items()

    
#DEPRECATED (and swiftly removed)
#class SimpleStorage(EasyStorageBase):
#    """A SimpleStorage Object """
#
#    security = ClassSecurityInfo()
#
#    security.declarePrivate('manage_save')
#    def manage_save(self,name,value,editablecontainer):
#        _storage = getattr(editablecontainer.aq_base,'_' + name + '_storage',None)
#        if _storage is not None and _storage!=self.id:
#            storage = self.getStorage(_storage)
#            if storage is not None:
#                storage.manage_delete(name, editablecontainer)
#            else: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)
#
#        setattr(editablecontainer.aq_base,name,value)
#
#    security.declarePrivate('manage_load')
#    def manage_load(self,name,editablecontainer,default=None):
#        return getattr(editablecontainer.aq_base,name,default)
#
#    security.declarePrivate('manage_delete')
#    def manage_delete(self, name, editablecontainer):
#        delattr(editablecontainer, name)
#Globals.InitializeClass(SimpleStorage)
#def initialize(context):
#    """Initialize Storage Product"""
#
#    #context.registerEasyStorage(SimpleStorage,'SimpleStorage')

