# $Header: /usr/custom/cvs/public/EasyPublisher/lib/python/Products/EasyEditor/Storage/Attic/ZBabelObjectStorage.py,v 1.1.2.2 2002/08/13 08:07:06 johanc Exp $
#
# (c) 2002, Torped Strategi och Kommunikation AB.
# See License.txt for License information.
#

#THIS WIL PROBABLY NOT WORK

__doc__="""ZBabelObjectStorage

$Torped: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.1.2.2 $'[11:-2]

import Globals
from Storage import EasyStorageBase
#from Products.ZBabel.ZBabelObject import manage_addZBabelObject
from OFS.DTMLMethod import addDTMLMethod
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base

from zLOG import LOG, ERROR
import sys

StringType = type('')

class ZBabelObjectStorage(EasyStorageBase):
    """A ZBabelObjectStorage Object """

    security = ClassSecurityInfo()

    def _saveZBabelObject(self, name, value, editablecontainer):
        if name not in editablecontainer.objectIds(spec='ZBabel Object'):
            try:
                editablecontainer.manage_addProduct['ZBabel'].manage_addZBabelObject(name, title=name, meta_type='DTML Method')
            except:
                LOG("ZBabelObjectStorage:_saveZBabelObject",ERROR, "Can't create an EditableRegion named '%s' in '%s'" % (name,editablecontainer.getId()), error=sys.exc_info())
        try:
            zbo = editablecontainer._getOb(name)
        except:
            zbo = editablecontainer
        language=zbo.findPreferredLanguage()
        if language not in zbo.objectIds(spec='DTML Method'):
            addDTMLMethod(zbo, language, language)
        obj = zbo._getOb(language)
        obj.manage_edit(value,obj.title)
        setattr(aq_base(editablecontainer),'_' + name + '_storage',self.id)

    security.declarePrivate('manage_save')
    def manage_save(self,name,value,editablecontainer):
        _storage = getattr(aq_base(editablecontainer),'_' + name + '_storage',None)
        if _storage is not None and _storage!=self.id:
            storage = self.getStorage(_storage)
            if storage is not None and hasattr(editablecontainer,name):
                storage.manage_delete(name, editablecontainer)
            elif storage is None: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)
        self._saveZBabelObject(name,value,editablecontainer)

    security.declarePrivate('manage_load')
    def manage_load(self,name,editablecontainer,default=None):
        language='en'
        if name in editablecontainer.objectIds(spec='ZBabel Object'):
            zbo = editablecontainer._getOb(name)
            language=zbo.findPreferredLanguage()
            if language and language in zbo.objectIds(spec='DTML Method'):
                return zbo._getOb(language)
            else:
                return getattr(aq_base(zbo), name, default)
        else:
            return getattr(aq_base(editablecontainer), name, default)

    security.declarePrivate('manage_delete')
    def manage_delete(self, name, editablecontainer):
        editablecontainer._delObject( name)


Globals.InitializeClass(ZBabelObjectStorage)




def initialize(context):
    """Initialize Storage Product"""

    context.registerEasyStorage(ZBabelObjectStorage,'ZBabelObjectStorage')

